#include "data.h"
#include "stdafx.h"
#include <utility>
#include <string>

using namespace std;

IMPEXP
std::pair< std::pair<CvMat*, CvMat*>, CvMat*> ReadTextons(string const & texton_xml_file)
{
    CvFileStorage * tfsr = cvOpenFileStorage(texton_xml_file.c_str(), NULL, CV_STORAGE_READ);

    // if we dont clone matrices then upon the release of the file storage,
    // matrices are disposed(!) too
    CvMat * cmeans = cvCloneMat((CvMat*)cvRead(tfsr, cvGetFileNodeByName(tfsr, NULL, "cmeans"), NULL));
    CvMat * covmat = cvCloneMat((CvMat*)cvRead(tfsr, cvGetFileNodeByName(tfsr, NULL, "sqrtinvcovmat"), NULL));
    CvMat * cmeansnorm = cvCloneMat((CvMat*)cvRead(tfsr, cvGetFileNodeByName(tfsr, NULL, "cmeansnorm"), NULL));
    cvReleaseFileStorage(&tfsr);
    return make_pair( make_pair(cmeans, covmat), cmeansnorm);
}
